/*
 * ICESOFT COMMERCIAL SOURCE CODE LICENSE V 1.1
 *
 * The contents of this file are subject to the ICEsoft Commercial Source
 * Code License Agreement V1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of the
 * License at
 * http://www.icesoft.com/license/commercial-source-v1.1.html
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under
 * the License.
 *
 * Copyright 2009-2015 ICEsoft Technologies Canada, Corp. All Rights Reserved.
 */
package com.icesoft.net.messaging;

import com.icesoft.util.Properties;

import java.io.Serializable;

public interface MessagePublisher {
    void publish(Serializable objectMessage);

    void publish(Serializable objectMessage, Properties messageProperties);

    void publish(Serializable objectMessage, Properties messageProperties, String messageType);

    void publish(Serializable objectMessage, String messageType);

    void publish(String textMessage);

    void publish(String textMessage, Properties messageProperties);

    void publish(String textMessage, Properties messageProperties, String messageType);

    void publish(String textMessage, String messageType);

    void publishNow(Serializable objectMessage);

    void publishNow(Serializable objectMessage, Properties messageProperties);

    void publishNow(Serializable objectMessage, Properties messageProperties, String messageType);

    void publishNow(Serializable objectMessage, String messageType);

    void publishNow(String textMessage);

    void publishNow(String textMessage, Properties messageProperties);

    void publishNow(String textMessage, Properties messageProperties, String messageType);

    void publishNow(String textMessage, String messageType);
    
    void stop();
}
